import JSBI from 'jsbi';
import { PathElements } from '../../types/neat';
export declare class Float32 {
    static type: 'float32';
    type: 'float32';
    value: number;
    /**
     * A class to represent an explicit float32
     */
    constructor(value: unknown);
    toString(): string;
}
export declare class Float64 {
    static type: 'float64';
    type: 'float64';
    value: number;
    /**
     * A class to represent an explicit float64
     */
    constructor(value: unknown);
    toString(): string;
}
export declare class Int {
    static type: 'int';
    type: 'int';
    value: number | bigint | JSBI;
    /**
     * A class to represent an explicit int
     */
    constructor(value: unknown, forceJSBI?: boolean);
    toString(): string;
}
export declare class Bool {
    static type: 'bool';
    type: 'bool';
    value: boolean;
    /**
     * A class to represent an explicit boolean
     */
    constructor(value: unknown);
    toString(): string;
}
export declare class Nil {
    static type: 'nil';
    type: 'nil';
    value: null;
    /**
     * A class to represent an explicit Nil
     */
    constructor();
    toString(): string;
}
export declare class Str {
    static type: 'str';
    type: 'str';
    value: string;
    /**
     * A class to represent an explicit String
     */
    constructor(value: unknown);
    toString(): string;
}
export declare class Pointer {
    static type: 'ptr';
    value: PathElements;
    type: 'ptr';
    delimiter: string;
    /**
     * A class to represent a Pointer type.
     * A Pointer is a pointer from one set of path elements to another.
     */
    constructor(value?: PathElements | string | unknown);
    toString(): string;
}
export declare class Wildcard {
    static type: '*';
    value: null;
    type: '*';
    /**
     * A class to represent a Wildcard type.
     * A Wildcard is a type that matches 1 or more path elements
     */
    constructor();
    toString(): string;
}
